-- HealthValues by Altariel

local VERSION = "1.10.0";
local RELEASEDATE = "June 4, 2006";
local CONFIGVERSION = 4;
local fadeTime = 3;
local fadeStartAlpha = 1.0;
local fadeEndAlpha = 0.0;
local alreadyFadedHealthOut = false;
local alreadyFadedHealthIn = false;
local alreadyFadedManaOut = false;
local alreadyFadedHealthIn = false;

HealthValuesDetails = {
		name = "HealthValues",
		description = "Shows player health and mana/rage/energy",
		version = VERSION,
		releaseDate = RELEASEDATE,
		author = "Altariel",
		email = "altariel@subpop.net",
		website = "http://subpop.net/wow",
		category = MYADDONS_CATEGORY_BARS,
		frame = "HealthValuesBase",
		optionsframe = "HealthValuesOptions"
	};


function HealthValues_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");

	SLASH_HEALTHVALUES1 = "/healthvalues";
	SLASH_HEALTHVALUES2 = "/hv";
	SlashCmdList["HEALTHVALUES"] = HealthValues_SlashCmd;
	
	DEFAULT_CHAT_FRAME:AddMessage("HealthValues " .. VERSION .. " loaded.");
end

function HealthValues_HealthOnLoad()  
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("UNIT_MAXHEALTH");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("VARIABLES_LOADED");
end

function HealthValues_HealthOnEvent(arg1)
	local hitpoints = UnitHealth("player") .. "/" .. UnitHealthMax("player");
	HealthValue:SetText(hitpoints);
	if(HealthValuesSettings.ShowHealth) then
		HealthValue:Show();
	else
		HealthValue:Hide();
	end

	if(HealthValuesSettings.Fading) then
		if(UnitHealth("player") < UnitHealthMax("player") and not alreadyFadedHealthIn) then
			UIFrameFadeIn(HealthValuesFrame,0,fadeEndAlpha,fadeStartAlpha);
			alreadyFadedHealthOut = false;
			alreadyFadedHealthIn = true;
		elseif(UnitHealth("player") == UnitHealthMax("player") and not alreadyFadedHealthOut) then
			UIFrameFadeOut(HealthValuesFrame,fadeTime,fadeStartAlpha,fadeEndAlpha);
			alreadyFadedHealthOut = true;
			alreadyFadedHealthIn = false;
		end
	end
end

function HealthValues_HealthOnEnter()
	if(HealthValuesSettings.Fading and UnitHealth("player") == UnitHealthMax("player")) then
		UIFrameFadeIn(HealthValuesFrame,0.5,fadeEndAlpha,fadeStartAlpha);
	end
end

function HealthValues_HealthOnLeave()
	if(HealthValuesSettings.Fading and UnitHealth("player") == UnitHealthMax("player")) then
		UIFrameFadeOut(HealthValuesFrame,0.5,fadeStartAlpha,fadeEndAlpha);
	end
end

function HealthValues_ManaOnLoad()  
	this:RegisterEvent("UNIT_MANA");
	this:RegisterEvent("UNIT_RAGE");
	this:RegisterEvent("UNIT_FOCUS");
	this:RegisterEvent("UNIT_ENERGY");
	this:RegisterEvent("UNIT_MAXMANA");
	this:RegisterEvent("UNIT_MAXRAGE");
	this:RegisterEvent("UNIT_MAXFOCUS");
	this:RegisterEvent("UNIT_MAXENERGY");
	this:RegisterEvent("UNIT_DISPLAYPOWER");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("VARIABLES_LOADED");
end


function HealthValues_ManaOnEvent(arg1)
	local mana = UnitMana("player") .. "/" .. UnitManaMax("player");
	ManaValue:SetText(mana);
	if(HealthValuesSettings.ShowMana) then
		ManaValue:Show();
	else
		ManaValue:Hide();
	end

	if(HealthValuesSettings.Fading) then
		local PowerType = UnitPowerType("player");
		if(PowerType == 1) then -- Rage: reverse the logic
			if(UnitMana("player") > 0) then
				UIFrameFadeIn(ManaValuesFrame,0,fadeEndAlpha,fadeStartAlpha);
				alreadyFadedManaOut = false;
			elseif(UnitMana("player") == 0 and not alreadyFadedManaOut) then
				UIFrameFadeOut(ManaValuesFrame,fadeTime,fadeStartAlpha,fadeEndAlpha);
				alreadyFadedManaOut = true;
			end
		else
			if(UnitMana("player") < UnitManaMax("player")) then
				UIFrameFadeIn(ManaValuesFrame,0,fadeEndAlpha,fadeStartAlpha);
				alreadyFadedManaOut = false;
			elseif(UnitMana("player") == UnitManaMax("player") and not alreadyFadedManaOut) then
				UIFrameFadeOut(ManaValuesFrame,fadeTime,fadeStartAlpha,fadeEndAlpha);
				alreadyFadedManaOut = true;
			end
		end
	end
end

function HealthValues_ManaOnEnter()
	local PowerType = UnitPowerType("player");
	if(HealthValuesSettings.Fading) then
		if(PowerType == 1) then
			if(UnitMana("player") == 0) then
				UIFrameFadeIn(ManaValuesFrame,0.5,fadeEndAlpha,fadeStartAlpha);
			end
		else
			if(UnitMana("player") == UnitManaMax("player")) then
				UIFrameFadeIn(ManaValuesFrame,0.5,fadeEndAlpha,fadeStartAlpha);
			end
		end
	end
end

function HealthValues_ManaOnLeave()
	local PowerType = UnitPowerType("player");
	if(HealthValuesSettings.Fading) then
		if(PowerType == 1) then
			if(UnitMana("player") == 0) then
				UIFrameFadeOut(ManaValuesFrame,0.5,fadeStartAlpha,fadeEndAlpha);
			end
		else
			if(UnitMana("player") == UnitManaMax("player")) then
				UIFrameFadeOut(ManaValuesFrame,0.5,fadeStartAlpha,fadeEndAlpha);
			end
		end
	end
end

-- This set of tricks borrowed from CTMod_UnitFrames
HealthValues_OldShowTextStatusBarText = ShowTextStatusBarText;
function HealthValues_ShowTextStatusBarText(bar)
	if ( bar ~= PlayerFrameManaBar and bar ~= PlayerFrameHealthBar ) then
		HealthValues_OldShowTextStatusBarText(bar);
	end
end
ShowTextStatusBarText = HealthValues_ShowTextStatusBarText;

function HealthValues_OnEvent()
	if(event == "VARIABLES_LOADED") then
		if (not HealthValuesSettings) then
			HealthValuesSettings = {
				["Version"]    = CONFIGVERSION;        -- Int: Internal config version to handle upgrades to the config variable.
				["ShowHealth"] = true,                 -- Bool: handles displaying the health values.
				["ShowMana"]   = true,                 -- Bool: handles displaying the mana/energy/raid values.
				["Fading"]     = true,                 -- Bool: enable fading in/out of text if health/mana/energy is full, or rage is 0.
				                                       --       also will fade text in on mouseover.
				}
		end

		-- Register the addon in myAddOns
		if(myAddOnsFrame_Register) then
			myAddOnsFrame_Register(HealthValuesDetails, nil);
		end
		
	end
end

function HealthValues_SlashCmd(cmd)
	local str = string.lower(cmd);
	if(str == "health" or str == "hp") then
		HealthValues_ToggleHealthValue();
	elseif(str == "mana" or str == "rage" or str == "energy") then
		HealthValues_ToggleManaValue();
	elseif(str == "fade") then
		HealthValues_ToggleFading();
	elseif(str == "version") then
		DEFAULT_CHAT_FRAME:AddMessage("HealthValues version " .. VERSION);
	else
		if(HealthValuesOptions:IsVisible()) then
			HideUIPanel(HealthValuesOptions);
		else
			ShowUIPanel(HealthValuesOptions);
		end
	end
end

function HealthValues_OptionsOnShow()
	if(HealthValuesSettings.ShowHealth) then
		HealthValuesOptionsHealthValue:SetChecked(1);
	else
		HealthValuesOptionsHealthValue:SetChecked(0);
	end
	if(HealthValuesSettings.ShowMana) then
		HealthValuesOptionsManaValue:SetChecked(1);
	else
		HealthValuesOptionsManaValue:SetChecked(0);
	end
	if(HealthValuesSettings.Fading) then
		HealthValuesOptionsFading:SetChecked(1);
	else
		HealthValuesOptionsFading:SetChecked(0);
	end
end

function HealthValues_ToggleHealthValue()
	HealthValuesSettings.ShowHealth = not HealthValuesSettings.ShowHealth;
	HealthValues_HealthOnEvent();
end

function HealthValues_ToggleManaValue()
	HealthValuesSettings.ShowMana = not HealthValuesSettings.ShowMana;
	HealthValues_ManaOnEvent();
end

function HealthValues_ToggleFading()
	HealthValuesSettings.Fading = not HealthValuesSettings.Fading;
	if(not HealthValuesSettings.Fading) then
		UIFrameFadeIn(HealthValuesFrame,fadeTime,fadeEndAlpha,fadeStartAlpha);
		UIFrameFadeIn(ManaValuesFrame,fadeTime,fadeEndAlpha,fadeStartAlpha);
		alreadyFadedManaOut = false;
		alreadyFadedHealthOut = false;
		alreadyFadedHealthIn = true;
		alreadyFadedManaIn = true;
	end
	HealthValues_HealthOnEvent();
	HealthValues_ManaOnEvent();
end
